/********************************************************
*
* File:  Light_Controll.c
* Titel: Main fr Projekt LineControll
* Version: 0.1
* Stand: 30.5.2009
*
*
* Autor: Stefan Andres
* email: stefan@myandres.de
* Web: www.myandres.de
*
* Projekt steuert einen 433Mhz SAW Sender mit den Code fr
*  INTERTECHNO 
* Funkgerte an. 
* Die Steuerung ber RS232
*
* Weiter ist bereits vorbereitet auch andere Steuersysteme (CAN, ..)
* mit zu integrieren.
*
* Mehr in  Home_Controll.pdf
*
*
*********************************************************/


#include <avr/io.h>
#include <avr/interrupt.h>
#include <stdlib.h>
#include <string.h>
#include "main.h" //alle Zentralen Definitionen
#include "uart.h"
#include "tools.h"
#include "intertechno.h"

     

/* Eingabe Handler
*
* Strings die ber UART/Ethernet eigegeben wurden behandeln
*
* Format: <param1> <param2> <param3> <param4> ...
*
* Paramter 1,2 wird nur soviel Zeichen ausgewertet wie notwendig
*
* param1: Steuerkommando
*         I[ntertechno] | R[eset] | l[ist]
*
* weitere param: Siehe in den Routinen die sie bearbeiten
*
*/

int input_handler(char s[32]) {

uint16_t ui;


static char com[32];

    if (!(next_param(s, com, TRUE) == 0)) {
      switch (*com) {
        case 'I': intertechno(s); return 0; break;
		case 'E': ui=0b101111000000; intertechno_send(ui); break;
		case 'A': ui=0b011111000000; intertechno_send(ui); break;
        default: return -1;
      }
    }
	return 0;

} //inputhandler


/*
* Interrupt Service Routine des UART berwacht und
* Bei einen Return ('\r') die Verarbeitung
* auslt
*
*/

ISR (USART_RXC_vect) {

// Fangen von ankommenden Zeichen.

static char uart_buff[32];         // Zeichenpuffer
static int uart_buff_pointer = 0;  // Pointer auf Zeichenkette
unsigned char ch;


   ch = UDR;
   if (ch == '\r') {  // Return eingegen
      uart_newline();
          uart_buff[uart_buff_pointer++] = '\0' ;
		  cli(); // Interrupt unterbinden
          if (input_handler(uart_buff) != 0) uart_writeln("Error");
		  uart_write("HomeControll:>");
		  sei(); // Interrupt zulassen
      uart_buff_pointer = 0;
   }
   else {
     if (uart_buff_pointer < 31) {
        uart_putc(ch);  // echo an die Eingabe
        uart_buff[uart_buff_pointer++] = ch ;
     }
   }

} //ISR


// MAIN

int main(void) {

uart_init();
intertechno_init();
uart_newline();
uart_write("HomeControll:>");
sei(); //Interrupt zulassen

while (1) {

// ToDo Watchdog einbauen wenn UART hngt RESET.

  }

} // End MAIN
