/********************************************************
*
* File:  tools.c
* Titel: Include for handling of zentral Procedure/Funktions
* Version: 0.1
* Stand: 27.12.2009
*
*
* Autor: Stefan Andres
* email: stefan@myandres.de
* Web: www.myandres.de
*
*
* Realisiert:
*
* int int next_param(char *sin, char *sout ) 
*   ersten Parameter getrennt durch <space> ermitteln
* Return:
*    0 : Kein Parameter mehr vorhanden
*   >0 : Anzahl der Zeichen 
*
* 
*********************************************************/

#include <stdlib.h>
#include <ctype.h>


/*next_parameter
  
  Ermittelt den ersten Parameter in dem String *sin
  Schreibt diesen in *sout
  Entfernt den erstenn parameter aus *sin

  Return 0: Wenn kein Parameter mehr vorhanden sein
  Return n: Anzahl zeichen

  Achtung: der String muss am Ende eine /0 haben!!!
 
*/

int next_param(char *sin, char *sout, char upper ) {

char *p;
int i;

       
	p=sin; //pointer retten
	i=0;
	while (*sin == ' ') sin++ ; //fhrende blank entfernen 
	if (!(*sin)) return 0; //kein weiterer parameter
	while ((*sin != ' ') && (*sin)) {  //next bis zum <space> oder /0 und in sout kopieren
	  if (upper) *sout=toupper(*sin); else *sout=*sin;
	  sin++;
	  sout++;
	  i++;
    } //while
	*sout=0; //null ans Ende des String
	while (*sin) {  //verschieben des Inhaltes (Parameter-1) von sin.
	  *p=*sin;
	  sin++;
	  p++;
	}  //while
	*p=0; //null ans Ende des String
	return i ; 
} //next_param
